\documentclass{beamer}
\usepackage[utf8]{inputenc}
\usetheme{Warsaw}
\usepackage{blkarray}

\title{Multisource Rumor Spreading\\with Network Coding}
\author{Quentin Dufour\\advised by David Bromberg and Davide Frey}\institute{WIDE Seminar}

\begin{document}

\begin{frame}
  \titlepage
\end{frame}

\begin{frame}
  \frametitle{Introduction: Gossip and Dissemination}
  
  \begin{columns}
  \begin{column}{.5\textwidth}
    \begin{description}[align=left]
      \item [Gossip] Each nodes exchange information with its $k$ neighbours
      \item [Dissemination] Send a message to everyone in the network
      \item [Complete Dissemination] Every nodes in the network have received the message
    \end{description}
  \end{column}
  \begin{column}{.5\textwidth}
    \includegraphics[width=\textwidth]{gossip2.png}
  	  \[n = 6\]
  \end{column}
  \end{columns}
\end{frame}

\begin{frame}
  \frametitle{Problem: Dissemination uses lot of bandwidth}
\setlength{\parskip}{\baselineskip}
	The probabilistic nature of Gossip algorithms implies that dissemination uses more messages than needed

    \normalsize Bandwidth is often:
    \begin{itemize}
      \item expensive (Data transfer costs \textdollar0.087/GB on Azure\footnote{https://azure.microsoft.com/en-us/pricing/details/bandwidth/})
      \item limited (ADSL upload is in average 7.5 Mb/s in France\footnote{http://www.ariase.com/fr/vitesse/observatoire-debits.html})
    \end{itemize}

    \Large Can we use less bandwidth?
\end{frame}

\begin{frame}
  \frametitle{Related Works: Dissemination}
\setlength{\parskip}{\baselineskip}
    \begin{columns}
  \begin{column}{.4\textwidth}
    \begin{center}
    \includegraphics[width=0.8\textwidth]{push.png}

      Push protocols
    \end{center}
  \end{column}
  \begin{column}{.4\textwidth}
    \begin{center}
    \includegraphics[width=0.8\textwidth]{pull.png}

     Pull protocols
    \end{center}
  \end{column}
  \end{columns}


  Only for a single message dissemination \\
  \Large Any solution for multiple messages?
\end{frame}

\begin{frame}
  \frametitle{Network Coding, the intuition}
  \[ n = 5, |m| = 2 \]
  \begin{columns}
  \begin{column}{.4\textwidth}
    \begin{center}
    \includegraphics[width=0.8\textwidth]{butterfly1.png}

    8 packets
    \end{center}
  \end{column}
  \begin{column}{.4\textwidth}
    \begin{center}
    \includegraphics[width=0.8\textwidth]{butterfly3.png}
    
    6 packets
    \end{center}
  \end{column}
  \end{columns}
\end{frame}

\begin{frame}
  \frametitle{Network Coding, a generalization}

  \begin{columns}
  \begin{column}{.35\textwidth}
  \[ n = 5, |m| = 2 \]
  \begin{center}
    \includegraphics[width=0.9\textwidth]{butterfly2.png}

  6 packets
  \end{center}
  \end{column}
  \begin{column}{.65\textwidth}

  \setlength{\parskip}{\baselineskip}
  
Solved over a finite field $\mathbb{F}_{2^q}$.

  \begin{columns}
  \begin{column}{.5\textwidth}
\setlength{\parskip}{\baselineskip}

\textbf{Node D}

$[(m_1^{id}, 1)], m_1^{cont}$
$[(m_1^{id}, 3), (m_2^{id}, 5)], e_1$

$\begin{cases} 1m_1 + 0m_2 = m_1 \\ 3m_1+5m_2=e_1 \end{cases}$

\end{column}
\begin{column}{.5\textwidth}
\setlength{\parskip}{\baselineskip}

\textbf{Node E}

$[(m_2^{id}, 1)], m_2^{cont}$
$[(m_1^{id}, 7), (m_2^{id}, 2)], e_2$

$\begin{cases} 0m_1 + 1m_2 = m_2 \\ 7m_1+2m_2=e_2 \end{cases}$
\end{column}
\end{columns}

Limit decoding complexity by encoding messages only in the same group.

\end{column}
\end{columns}

\end{frame}

%\begin{frame}

%\frametitle{Network Coding, implementation with files}

%\includegraphics[width=\textwidth]{file-netcode.png}
%\[ G_1 = 
%  \begin{blockarray}{ccccc}
%   chunk\ 1 & chunk\ 2 & chunk\ 3 & ... & pl \\
%   \begin{block}{(ccccc)}
%	   5 & 8 & 12 & ... & e1 \\
%	   23 & 6 & 240 & ... & e2 \\
%	   ... & ... & ... & ... & ... \\ 
%	\end{block}
%	\end{blockarray}
%	\]
%
%\begin{itemize}
%  \item Generations limit the size of the matrix to solve
%  \item $1^{st}$ coefficient corresponds to $1^{st}$ chunk, etc.
%\end{itemize}

%It works because chunks are \textbf{ordered} inside a file. \\
%Doesn't work with independant events from multiple sources.

%\end{frame}

\begin{frame}
\frametitle{Contribution: network coding without ordered chunks}
\setlength{\parskip}{\baselineskip}
Use Lamport Timestamps to assign generation.\\
Messages with same clock value = Messages from same generation.

Generation's size will depend of the number of nodes, latency, rate, etc.
Changing Lamport Timestamps update rules to impact the generation's size.

\includegraphics[width=0.8\textwidth]{netcode-v1.png}
\end{frame}

\begin{frame}
\frametitle{Contribution: network coding without ordered chunks}

Messages inside a generation are not ordered.

\begin{itemize}
  \item A unique ID is generated for each chunk
  \item Instead of sending only the coefficient vector, we send a (msg id, coefficient) tuple
\end{itemize}
	Example: 
	\[ G = 
	  \begin{blockarray}{ccc}
	  id_{m_9} & id_{m_2} & pl \\
	  \begin{block}{(ccc)}
	  5 & 8 & e1 \\
	  \end{block}
	\end{blockarray}
	\]
	    \[\text{A new packet: } ((id_{m_4}, 240), e_2) \]

	\[ G = 
	\begin{blockarray}{cccc}
	  id_{m_9} & id_{m_2} & id_{m_4} & pl \\
          \begin{block}{(cccc)}
	  5 & 8 & 0 & e1 \\
          0 & 0 & 240 & e2 \\
	\end{block}
	\end{blockarray}
	\]
\end{frame}
	
\begin{frame}
  \frametitle{Better dissemination for same fanout}
  \includegraphics[width=\textwidth]{missed-1000.png}
\end{frame}

\begin{frame}
  \frametitle{Generation size is influenced by latency }
  \includegraphics[width=\textwidth]{graph-planet+static.png}
\end{frame}

 \begin{frame}
   \frametitle{Conclusion \& Future work}

   \textbf{Conclusion} 
~\\

     Network coding:
     \begin{itemize}
       \item improves multiple messages dissemination
       \item need to be configured to work
     \end{itemize}
~\\

     \textbf{Future work}
~\\

     Update algorithm to:
     \begin{itemize}
 	\item adapt configuration automatically to maintain a certain generation size
 	\item work with push-pull algorithms
     \end{itemize}
 
 \end{frame}


\end{document}
